Subject: Code paths setting gso_size

From: William Allen Simpson <[email-masked]>
Date: Sat, 13 Mar 2010 06:22:57 -0500

This is a new thread dedicated to a specific topic, spawned by an
earlier discussion.  I've CC'd only those that participated recently.

I've written:
# In this particular instance, I suggest that you take a look at all the
# places that gso_size is set, and cross index with all the code paths that
# place these TCP headers onto the txq without a check of doff -- as I did!
#
# I'll specifically mention the tun and virtio_net devices, but I'm also
# particularly concerned with af_packet.c and skbuff.c -- and the general
# problem with inet_lro.c, too.
#
# Amazingly enough, folks sometimes use Linux for routers....
#

Eric (and David) have written:
# Only *locally* generated trafic by linux kernel can enter this path.
#

So, let us begin with the tun device, and work our way through the others.